<cfinclude TEMPLATE="includes/enforcelogon.cfm">
<CFPARAM NAME="url.eventid" TYPE="numeric" DEFAULT="0">
<CFPARAM NAME="url.begin" TYPE="date" DEFAULT="#DateFormat(Now(), "mm/dd/yyyy")#">
<CFPARAM NAME="form.begin" TYPE="date" DEFAULT="#url.begin#">
<CFPARAM NAME="form.title" TYPE="string" DEFAULT="New Event">
<CFPARAM NAME="form.category" TYPE="numeric" DEFAULT="0">
<CFPARAM NAME="form.class" TYPE="numeric" DEFAULT="0">
<CFPARAM NAME="form.description" TYPE="string" DEFAULT="">

<CFSCRIPT>
  if(NOT (IsDefined("form.eventid") AND IsNumeric(form.eventid)))
    form.eventid = url.eventid;
  if(NOT (IsDefined("form.end") AND IsDate(form.end) AND form.end GT form.begin))
    form.end = form.begin;
</CFSCRIPT>

<html>
<head>
<title>Add an Event</title>
<script LANGUAGE="javascript" src="image/calendar.js"></script>
</head>
<body bgcolor="#cce6ff" vlink="blue" link="blue">

<CFIF IsDefined("save") OR IsDefined("saveand") OR IsDefined("delete")>
  <cfquery name="permission" datasource="ginyuu">
    SELECT ginyuu.udf_GetPrivileges('#session.userid#', '#form.category#', '#form.class#') AS privs;
  </cfquery>
  <cfloop query="permission">
    <cfset priv="#privs#">
  </cfloop>
  <cfif priv EQ 2>
    <cfif IsDefined("delete")>    
        <cfquery name="deletestuff" datasource="ginyuu">
          DELETE FROM events WHERE eventid = '#form.eventid#'
        </cfquery>
        <P><STRONG><FONT COLOR=BLUE>Deleted Record From Database</FONT></STRONG></P>          
    <cfelse>
      <cfif form.eventid GT 0>
        <cfquery name="savestuff" datasource="ginyuu">
          UPDATE events SET
          categoryid = '#form.category#',
          classid = <cfif form.class GT 0>'#form.class#'<cfelse>NULL</cfif>,
          begindate = '#form.begin#',
          enddate = '#form.end#',
          name = '#form.title#',
          description = '#form.description#'
          WHERE eventid = '#form.eventid#'
        </cfquery>
        <P><STRONG><FONT COLOR=BLUE>Updated data in database.</FONT></STRONG></P>
      <cfelse>
        <cfquery name="savestuff" datasource="ginyuu">
          INSERT INTO events(categoryid, classid, begindate, enddate, name, description)
          VALUES('#form.category#', <cfif form.class GT 0>'#form.class#'<cfelse>NULL</cfif>, '#form.begin#', '#form.end#', '#form.title#', '#form.description#')
        </cfquery>
        <P><STRONG><FONT COLOR=BLUE>Saved data in database.</FONT></STRONG></P>
      </cfif>
    </cfif>

    <cfset form.eventid=0>
    <cfset form.end=form.begin>
    <cfset form.title="">
    <cfset form.category=0>
    <cfset form.class=0>
    <cfset form.description="">
    
    <CFIF NOT IsDefined("saveand")>
      <script>window.close()</script>
    </CFIF>
    <script>if (window.opener) window.opener.location.reload(true);</script>
</script>
    
  <cfelse>
    <p><font color=red><strong>You do not have permission to create this type of event. Please select a different category or a different class.</strong></font></p>
  </cfif>
</CFIF>

<cfform name=f>

<CFIF NOT IsDefined("form.stale") AND form.eventid GT 0>
  <CFQUERY name="load" datasource="ginyuu">
    SELECT name, begindate, enddate, categoryid, classid, description FROM events WHERE eventid = '#form.eventid#'
  </CFQUERY>  
  <CFLOOP query="load">
    <cfset form.title="#name#">
    <cfset form.begin="#begindate#">
    <cfset form.end="#enddate#">
    <cfset form.category="#categoryid#">
    <cfset form.class="#classid#">
    <cfset form.description="#description#">
  </CFLOOP>
</CFIF>

<CFSET readonly=0>
<CFIF form.eventid GT 0>
<CFQUERY name="security" datasource="ginyuu">
  SELECT ginyuu.udf_GetPrivileges('#session.userid#','#form.category#','#form.class#') AS privs
</CFQUERY>
<CFSET readonly=1>
<CFLOOP query="security">
  <cfif #privs# EQ 2><cfset readonly=0></cfif>
</CFLOOP>
</CFIF>

<input type=hidden name=stale value="1">
<cfoutput><input type=hidden name=eventid value="#form.eventid#"></cfoutput>

<cfif readonly eq 0>
<table cellpadding=2 cellspacing=0 border=1 bordercolor="#555555" width="100%">
<tr bgcolor="#f4f5e1"> 
  <td nowrap align=right bgcolor="#336699">
    <input name=save type=submit value="Save">
    <cfif form.eventid GT 0>
      <input name=delete type=submit value="Delete">
    <cfelse>
      <input name=saveand type=submit value="Save and Enter Another">
    </cfif>
    <input name=cancel type=submit value="Cancel" onclick="window.close()">
  </td>
</tr>
</table>
</cfif>

<p>
<table cellpadding=2 cellspacing=0 border=1 bordercolor="#555555" width="100%">
<tr>
  <td align=center bgcolor="#dcdcdc"><font face="Arial,Helvetica"><b><cfif readonly eq 0><cfif form.eventid GT 0>Modify Event<cfelse>New Event</cfif><cfelse>View Event</cfif></b></font></td>
</tr>
<tr>
  <td bgcolor="#eeeeee">
    <table width="100%">
    <tr>
      <td><b><label for=title>Title:</label></b></td>
      <td width="100%"><cfif readonly eq 0><cfoutput><cfinput name=title id=title type=text value="#form.title#" style="width:100%" size=40 message="Please enter an event title." required="Yes"></cfoutput><cfelse><cfoutput>#form.title#</cfoutput></cfif></td>
    </tr>
    </table>
    <table>
    <tr>
      <td>
        <table width="100%">
        <tr>
          <td nowrap><b><label for=begin>Begin Date:</label></b></td>
          <td width="100%"><cfif readonly eq 0><cfoutput><cfinput name=begin type=text size=10 value="#DateFormat(form.begin,"M/D/YYYY")#" message="Please enter a starting date in MM/DD/YYYY format." validate="date" required="yes"></cfoutput><a href="javascript:void(new Datepicker(document.forms['f'].begin))"><IMG ALT="blank" src="image/picker.gif" width=22 height=21 border=0></a><cfelse><cfoutput>#DateFormat(form.begin,"M/D/YYYY")#</cfoutput></cfif></td>
        </tr>
        <tr>
          <td nowrap><b><label for=end>End Date:</label></b></td>
          <td width="100%"><cfif readonly eq 0><cfoutput><input name=end type=text size=10 value="<cfif NOT form.begin eq form.end>#DateFormat(form.end,"M/D/YYYY")#</cfif>"><a href="javascript:void(new Datepicker(document.forms['f'].end))"></cfoutput><IMG ALT="blank" src="image/picker.gif" width=22 height=21 border=0></a><cfelse><cfoutput><cfif NOT form.begin eq form.end>#DateFormat(form.end,"M/D/YYYY")#</cfif></cfoutput></cfif></td>
        </tr>
        </table>
      </td>
      <td>
        <table>
	<tr>
	  <td><b><label for=category>Category:</label></b></td>
	  <td>
          <cfif readonly eq 0>
	  <cfquery name="cat" datasource="ginyuu">
	  SELECT categoryid, name FROM categories AS c WHERE
          c.userid = '#session.userid#'
          OR
          ginyuu.udf_IsAllowed(2, '#session.userid#', NULL, c.allowstudent, c.allowta, c.allowprofessor) <> 0
  	  </cfquery>
          <select name=category id=category>
          <cfoutput query="cat"><option value="#categoryid#" <cfif category eq categoryid>selected</cfif>>#name#</option></cfoutput>
          </select><input name=editcategories id=editcategories type=button value="Edit Categories..." onclick="alert('Coming soon...')">
          <cfelse>
          <cfquery name="catg" datasource="ginyuu">SELECT name FROM categories WHERE categoryid='#form.category#'</cfquery>
          <cfoutput query="catg">#name#</cfoutput>
          </cfif>
          </td>
        </tr>
        <tr>
          <td><b><label for=class>Class:</label></b></td>
          <td>
          <cfif readonly eq 0>
          <cfquery name="classes" datasource="ginyuu">SELECT cl.classid, cl.name FROM enrollments AS e INNER JOIN classes AS cl ON cl.classid = e.classid WHERE userid = '#session.userid#'</cfquery>
          <select name=class ID=class><option value=0></option><cfoutput query="classes"><option value="#classid#" <cfif class eq classid>selected</cfif>>#name#</option></cfoutput></select>
          <cfelse>
          <cfquery name="classs" datasource="ginyuu">SELECT name FROM classes WHERE classid='#form.class#'</cfquery>
          <cfoutput query="classs">#name#</cfoutput>
          </cfif>
          </td>
        </tr>
        </table>
      </td>
    </tr>
    </table>
    <table width="100%">
    <tr>
      <td valign=top><b><label for=description>Desciption:</label></b></td>
      <td width="100%"><cfif readonly eq 0><textarea name=description id=description type=text style="width:100%" rows=10 cols=60><cfoutput>#form.description#</cfoutput></textarea><cfelse><pre style="width:100%; height:250px; background-color:#FFFFFF; padding:5px; border-color:black"><cfoutput>#form.description#</cfoutput></pre></cfif></td>
    </tr>
    </table>
  </td>
</tr>
</table>    

<p>

<cfif readonly eq 0>
<table cellpadding=2 cellspacing=0 border=1 bordercolor="#555555" width="100%">
<tr bgcolor="#f4f5e1"> 
  <td nowrap align=right bgcolor="#336699">
    <input name=save type=submit value="Save">
    <cfif form.eventid GT 0>
      <input name=delete type=submit value="Delete">
    <cfelse>
      <input name=saveand type=submit value="Save and Enter Another">
    </cfif>
    <input name=cancel type=submit value="Cancel" onclick="window.close()">
  </td>
</tr>
</table>
</cfif>

</cfform>

</body>
</html>